Option Explicit On 
Option Strict On
Option Compare Binary

Imports System
Imports System.Windows.Forms

' <remarks>
'   Erweitert das Standard-ListBox-Steuerelement 
'   um die Mglichkeit, diese zu sperren, sodass der
'   Benutzer die Auswahl und den Inhalt nicht manipulieren kann.
' </remarks>
Public Class ExtendedListBox
    Inherits ListBox

    Private Const WM_KEYDOWN As Int32 = &H100
    Private Const WM_LBUTTONDOWN As Int32 = &H201
    Private Const WM_SETFOCUS As Int32 = &H7

    Private m_blnLocked As Boolean

    ' <summary>
    '   Erstellt eine neue Instanz der Klasse.
    ' </summary>
    Public Sub New()
        MyBase.New()
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        MyBase.Dispose(disposing)
    End Sub

    Protected Overrides Sub WndProc(ByRef m As System.Windows.Forms.Message)
        If m_blnLocked Then
            If m.Msg = WM_KEYDOWN Or m.Msg = WM_LBUTTONDOWN Or _
                m.Msg = WM_SETFOCUS Then

                Return
            End If
        End If
        MyBase.WndProc(m)
    End Sub

    ''' <summary>
    '''   Gibt an oder zurck, ob der Inhalt und die Auwahl gesperrt sein soll.
    ''' <summary>
    ''' <value>Wert, der angibt, ob die Auswahl gendert werden kann.</value>
    Public Property Locked() As Boolean
        Get
            Return m_blnLocked
        End Get
        Set(ByVal Value As Boolean)
            m_blnLocked = Value
        End Set
    End Property
End Class